// actfact.hpp -- the base class for action factories
//
// Written by Frederic Bouvier, started May 2002.
//
// Copyright (C) 2002  Frederic Bouvier - fredb@users.sourceforge.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: actfact.hpp,v 1.3 2002/06/01 20:56:20 fredb Exp $

#ifndef _actfact_hpp_
#define _actfact_hpp_

#include <string>

class FGSD_Action;
class SGPropertyNode;

class FGSD_ActionFactory {
   public:
      FGSD_ActionFactory();
      virtual ~FGSD_ActionFactory() {}

      virtual FGSD_Action *createAction( const char *__project, SGPropertyNode * ) = 0;

      virtual std::string getName() const = 0;

   protected:
      FGSD_ActionFactory *_next;
      static FGSD_ActionFactory *_last;

   friend class FGSD_ActionManager;
};

#endif
