// actionwin.hpp -- the undo/redo popup window
//
// Written by Frederic Bouvier, started June 2002.
//
// Copyright (C) 2002  Frederic Bouvier - fredb@users.sourceforge.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: actionwin.hpp,v 1.6 2005/05/09 07:01:48 fredb Exp $

#ifndef _actionwin_hpp_
#define _actionwin_hpp_

#include <FL/Fl_Window.H>
#include <FL/Fl_Multi_Browser.H>
#include <FL/Fl_Box.H>

class FGSD_MainWindow;

class FGSD_ActionBrowser : public Fl_Multi_Browser {
   public:
      FGSD_ActionBrowser( int x, int y, int w, int h, bool u, Fl_Box *o );
      int handle( int e );

      bool leave;

   private:
      void *current;
      int ind;
      Fl_Box *output;
      bool undo;
      std::string label;
};

class FGSD_ActionWindow : public Fl_Window {
   public:
      FGSD_ActionWindow( FGSD_MainWindow * __mainWindow, int x, int y, int w, int h, bool undo );
      ~FGSD_ActionWindow();

      int handle( int event );
      void show();

      static void list_cb( Fl_Widget *, void *);
      void list_cb( Fl_Widget *);

   private:
      FGSD_ActionBrowser *_list;
      Fl_Box *_output;
      FGSD_MainWindow *_mainWindow;
      int _x;
      int _y;
      int _width;
      int _height;
      bool _undo;
      bool _exit;
};

#endif
