// curvetools.hpp -- the toolbar for curve operations
//
// Written by Frederic Bouvier, started March 2003.
//
// Copyright (C) 2003  Frederic Bouvier - fredb@users.sourceforge.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: curvetools.hpp,v 1.6 2005/05/09 07:01:51 fredb Exp $

#ifndef _curvetools_hpp_
#define _curvetools_hpp_

#include <FL/Fl_Group.H>
#include <FL/Fl_Button.H>

class FGSD_MainWindow;

class FGSD_CurveToolbar : public Fl_Group {
   public:
      FGSD_CurveToolbar( int x, int y, int w, int h, FGSD_MainWindow *mw );

      void show( bool yes = true );
      bool addPoint() const { return _addPoint->value(); }

   private:
      static void addPoint( Fl_Widget *w, void *v );
      static void delPoint( Fl_Widget *w, void *v );
      static void delCurve( Fl_Widget *w, void *v );
      static void embedCurve( Fl_Widget *w, void *v );
      static void properties( Fl_Widget *w, void *v );
      static void drawCurve( Fl_Widget *w, void *v );

   private:
      FGSD_MainWindow *_mainWindow;
      Fl_Button *_addPoint;
      Fl_Button *_delPoint;
      Fl_Button *_delCurve;
      Fl_Button *_embedCurve;
      Fl_Button *_properties;
      Fl_Button *_drawCurve;
};

#endif
