// fragmentact.hpp -- fragment actions
//
// Written by Frederic Bouvier, started May 2002.
//
// Copyright (C) 2002  Frederic Bouvier - fredb@users.sourceforge.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: fragmentact.hpp,v 1.4 2002/06/01 20:56:20 fredb Exp $

#ifndef _fragmentact_hpp_
#define _fragmentact_hpp_

#include "action.hpp"

class FGSD_MoveFragmentAction : public FGSD_Action {
   public:
      enum Type { Up, Down };
      FGSD_MoveFragmentAction( bool __up );
      FGSD_MoveFragmentAction( const char *__name, bool __up, size_t nb );

      bool undo();
      bool redo( bool __step = false );
      std::string name() const;
      std::string description() const;
      bool combine( FGSD_Action *__action );
      FGSD_ActionID type() const;
      void *convertTo( FGSD_ActionID __id );
      FGSD_Action *clone() const;

      bool save( const char *__project, SGPropertyNode *__node );
      bool load( const char *__project, SGPropertyNode *__node );

      static FGSD_ActionID _id;

   private:
      bool _up;
      std::string _name;
      size_t _nb;
};

class FGSD_AddRemoveFragmentAction : public FGSD_Action {
   public:
      FGSD_AddRemoveFragmentAction( bool __add );
      FGSD_AddRemoveFragmentAction( bool __add, const char *__name, size_t __nb = 0 );

      bool undo();
      bool redo( bool __step = false );
      std::string name() const;
      std::string description() const;
      FGSD_ActionID type() const;
      void *convertTo( FGSD_ActionID __id );
      FGSD_Action *clone() const;

      bool save( const char *__project, SGPropertyNode *__node );
      bool load( const char *__project, SGPropertyNode *__node );
      size_t weight( SGPropertyNode *__node );

      static FGSD_ActionID _id;

   private:
      bool _add;
      std::string _name;
      size_t _nb;
};

#endif
