// gifimage.hpp -- image data from gif file
//
// Written by Frederic Bouvier, started October 2004.
//
// Copyright (C) 2004  Frederic Bouvier - fredb@users.sourceforge.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: gifimage.hpp,v 1.2 2005/05/09 07:01:52 fredb Exp $

#ifndef gifimage_h
#define gifimage_h 1

#include <stdlib.h>

// image
#include "image.hpp"

class FGSD_GIFImage : public FGSD_Image
{
   public:
      FGSD_GIFImage(bool __reverted = false);
      ~FGSD_GIFImage ();

      bool load (const char *__fileName);
      bool loadFromBuffer( const unsigned char *__buffer, size_t __len );

   private:
      static int readData_cb(void*,unsigned char*,int);
      int readData(unsigned char*,int);
      bool _reverted;
      int _sent;
      const unsigned char *_buffer;
      size_t _len;
};

#endif
