// teximage.hpp -- Image data for OpenGL textures
//
// Written by Frederic Bouvier, started October 2001.
//
// Copyright (C) 2001  Frederic Bouvier - fredb@users.sourceforge.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: teximage.hpp,v 1.2 2002/02/03 22:16:00 fredb Exp $

#ifndef _teximage_hpp_
#define _teximage_hpp_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "stddef.h"

// image
#include "image.hpp"

class FGSD_TexImage : public FGSD_Image {

   public:
      FGSD_TexImage( FGSD_Image *__image, size_t __comp, size_t __size, size_t __x, size_t __y );
      ~FGSD_TexImage();

      bool load(const char *__fileName) { return false; }
      GLuint texName() const;

   private:
      GLuint _texName;
};

inline
GLuint FGSD_TexImage::texName() const
{
   return _texName;
}

#endif
