// window.hpp -- a window with modal functionality
//
// Written by Frederic Bouvier, started February 2004.
//
// Copyright (C) 2004  Frederic Bouvier - fredb@users.sourceforge.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: window.hpp,v 1.1 2004/02/14 14:17:41 fredb2 Exp $

#ifndef _window_hpp_
#define _window_hpp_

#include <FL/Fl_Window.H>

class FGSD_Window : public Fl_Window {
   public:
      FGSD_Window( int x, int y, const char *title = 0 ) : Fl_Window( x,y,title ), v( -1 ) {}
      FGSD_Window( int x, int y, int w, int h, const char *title = 0 ) : Fl_Window( x,y,w,h,title ), v( -1 ) {}
      bool exec();
      void clear_value() { v = 0; }
      void set_value() { v = 1; }
   private:
      int v;
};

#endif
